% Fort. Applikationssoftware
% Perlin-Noise zum Generieren von fraktalen Wolken
 
 function perlin (m)
 
 m=200;       % Grsse des erzeugten Bildes
 s=zeros(m);
 
 w=m;   % fuer die Wichtung
 i=0;   % Interationen 
 
 while w > 3
     i=i+1;
     d=interp2(randn(w), i, 'spline');

     s=s+i*d(1:m,1:m);
     w=ceil(w/2-1);
 end
 
% s soll zwischen 0 und 1 liegen
s = s - min(s(:));
s = s/max(s(:));

% Parametereinstellungen
de = 0.5;   % Dichte
sh = 0.1;   % Schaerfe der Wolken

s = 1 - exp(-(s - de)*sh);
s(s<0) = 0;

% Skalierung zwischen 0 und 255
s = s/max(s(:));
s = round(s*255);

mesh(s);
imagesc(s);
 
% Colormap erzeugen
c = [0.25 0.5 1];
for b = 2:256
    c(b,:)=(b-2)/256*(1-c(1,:))+c(1,:);
end

colormap(c);
axis off