% Fort. Applikationssoftware
% Perlin-Noise zum Generieren von fraktalen Landschaften
 
 function perlin (m)
 
 clear all
 
 m=200;       % Gr�sse des erzeugten Bildes
 s=zeros(m);
 
 w=m;   % fuer die Wichtung
 i=0;   % Interationen 
 
 while w > 3
     i=i+1;
     d=interp2(randn(w), i, 'spline');

     s=s+i*d(1:m,1:m);
     w=ceil(w/2-1);
 end
 
% s soll zwischen 0 und 1 liegen
s = s - min(s(:));
s = s/max(s(:));

% Parametereinstellungen
de = 0.55;   % Dichte
sh = 0.1;   % Schaerfe der Wolken

s = 1 - exp(-(s - de)*sh);
s(s<0) = 0;

% Skalierung zwischen 0 und 255
s = s/max(s(:));
s = round(s*255);

% figure(1)
% sh = surf(s);
% set(sh,'FaceColor','flat','EdgeColor','none');
% view([30,50]);
% camlight left;
% colormap([[.1 .8 1]; summer(512)]);
% shading interp
% 
% set(gca,'Color',[1 1 1],'GridLineStyle','none','XColor',[.8 .8 .8],'YColor',[.8 .8 .8],'ZColor',[.8 .8 .8]);  


% Filter
f = 5; % definiert ueber wie viele Werte gemittelt wird
F = ones(f,f) / f^2;    % ausprobieren ob man auch wichten kann
SF = filter2(F,s,'valid');

ff=figure(2);
sf = surf(SF);
set(sf,'FaceColor','flat','EdgeColor','none');
colormap([[.1 .8 1]; summer(512)]);
shading interp
set(gca,'Color',[1 1 1],'GridLineStyle','none','XColor',[.8 .8 .8],'YColor',[.8 .8 .8],'ZColor',[.8 .8 .8]);  
view([30,50]);
cl=camlight('left');
for az = 30:5:390    % Rotation der Achse
    view([az,50]);
    camlight(cl,'left');
    drawnow;
    pause(0.2);
end

